<template>
  <div v-if="type == 'image'">
    <ul v-for="(item,index) in value" :key="index" class="el-upload-list el-upload-list--picture-card">
      <li tabindex="0" class="el-upload-list__item is-ready" :style="'width: '+width+'px;height: '+height+'px'">
        <div>
          <img :src="item" alt="" class="el-upload-list__item-thumbnail">
          <span class="el-upload-list__item-actions">
            <span v-if="index != 0" class="el-upload-list__item-preview" @click="moveMaterial(index,'up')">
              <i class="el-icon-back" />
            </span>
            <span class="el-upload-list__item-preview" @click="zoomMaterial(index)">
              <i class="el-icon-view" />
            </span>
            <span class="el-upload-list__item-delete" @click="deleteMaterial(index)">
              <i class="el-icon-delete" />
            </span>
            <span v-if="index != value.length-1" class="el-upload-list__item-preview" @click="moveMaterial(index,'down')">
              <i class="el-icon-right" />
            </span>
          </span>
        </div>
      </li>
    </ul>
    <div v-if="num > value.length" tabindex="0" class="el-upload el-upload--picture-card" :style="'width: '+width+'px;height: '+height+'px;'+'line-height:'+height+'px;'" @click="toSeleteMaterial">
      <i class="el-icon-plus" />
    </div>
    <!-- 查看 -->
    <el-dialog
      append-to-body
      :visible.sync="dialogVisible"
      width="35%"
    >
      <img :src="materialUrl" alt="" style="width: 100%">
    </el-dialog>
    <!-- 素材列表 -->
    <el-dialog
      title="朋友圈图片素材库"
      append-to-body
      :visible.sync="listDialogVisible"
      width="70%"
    >
      <el-container>
        <el-aside width="unset">
          <div style="margin-bottom: 10px">
            <el-button
              class="el-icon-plus"
              size="small"
              @click="materialgroupAdd()"
            >
              添加分组
            </el-button>
          </div>
          <div class="group-list">
            <div class="group-item" v-for="(group) in materialGroupList">
                <el-button  @click="selectGroup(group)" type="primary" plain >{{group.materialGroupName}}</el-button>
            </div>
          </div>
        </el-aside>
        <el-main>
          <el-card>
            <div slot="header">
              <el-row>
                <el-col :span="12">
                  <span>{{ materialGroup.materialGroupName }}</span>
                  <span v-if="materialGroup.materialGroupId >0">
                    <el-button size="small" type="text" class="el-icon-edit" style="margin-left: 10px;" @click="materialgroupEdit(materialGroup)">重命名</el-button>
                    <el-button size="small" type="text" class="el-icon-delete" style="margin-left: 10px;color: red" @click="materialgroupDelete(materialGroup)">删除</el-button>
                  </span>
                </el-col>
                <el-col :span="12" style="text-align: right;">
                  <el-upload
                    :action="uploadUrl"
                    :file-list="[]"
                    :on-progress="handleProgress"
                    :before-upload="beforeUpload"
                    :on-success="handleSuccess"
                    :data="{type: 1}"
                    multiple
                  >
                    <el-button size="small" type="primary">批量上传</el-button>
                  </el-upload>
                </el-col>
              </el-row>
            </div>
            <div v-loading="tableLoading">
              <el-alert
                v-if="tableData.length <= 0"
                title="暂无数据"
                type="info"
                :closable="false"
                center
                show-icon
              />
              <el-row :gutter="5">
                <el-checkbox-group v-model="urls" :max="num - value.length">
                  <el-col v-for="(item,index) in tableData" :key="index" :span="4">
                    <el-card :body-style="{ padding: '5px' }">
                      <el-image
                        style="width: 100%;height: 100px"
                        :src="item.materialUrl"
                        fit="contain"
                        :preview-src-list="[item.materialUrl]"
                        :z-index="9999"
                      />
                      <div>
                        <el-checkbox class="material-name" :label="item.materialUrl">
                          选择
                        </el-checkbox>
                        <el-row>
                          <el-col :span="24" class="col-do">
                            <el-button type="text" size="medium" @click="materialDel(item)">删除</el-button>
                          </el-col>
                        </el-row>

                      </div>
                    </el-card>
                  </el-col>
                </el-checkbox-group>
              </el-row>
               <pagination
                  v-show="total>0"
                  :total="total"
                  :page.sync="queryParams.pageNum"
                  :limit.sync="queryParams.pageSize"
                  @pagination="getMaterialList"
                />

            </div>
          </el-card>
        </el-main>
      </el-container>
      <span slot="footer" class="dialog-footer">
        <el-button @click="listDialogVisible = false">取 消</el-button>
        <el-button type="primary" @click="submit">确 定</el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script>
import {addMaterial, delMaterial, listMaterial,} from "@/api/qw/material";
import {addMaterialGroup, delMaterialGroup, listMaterialGroup, updateMaterialGroup} from "@/api/qw/materialGroup";

export default {
  name: 'ImageSelect',
  props: {
    // 素材数据
    value: {
      type: Array,
      default() {
        return []
      }
    },
    // 素材类型
    type: {
      type: String
    },
    // 素材限制选择数量,最多9个
    num: {
      type: Number,
      default() {
        return 9
      }
    },
    // 宽度
    width: {
      type: Number,
      default() {
        return 150
      }
    },
    // 宽度
    height: {
      type: Number,
      default() {
        return 150
      }
    }
  },
  data() {
    return {
      uploadUrl:process.env.VUE_APP_BASE_API+"/common/uploadOSS",
      dialogVisible: false,
      materialUrl: '',
      listDialogVisible: false,
      //素材组列表
      materialGroupList: [],
      materialGroupLoading: false,
      //选择的某个素材组
      materialGroup:{},
      tableData: [],
      resultNumber: 0,
      total: 0,
      //查询素材列表
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        groupType:2,
        materialGroupName: null,
        materialGroupId:null,
        materialUrl: null,
        createUserId: null,
      },
      tableLoading: false,
      urls: []
    }
  },
  mounted(){
    this.getAllMaterialGroup();
  },
  methods: {
    //查询素材组下的素材列表
    selectGroup(item){
      this.materialGroup=item;
      this.queryParams.materialGroupId=item.materialGroupId;
      this.getMaterialList();
    },
    //添加分组
    materialgroupAdd() {
      const that = this
      this.$prompt('请输入分组名', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消'
      }).then(({ value }) => {
        addMaterialGroup({
          materialGroupName: value,
          groupType:2
        }).then(function() {
          that.materialGroup={};
          that.getAllMaterialGroup();
        })
      }).catch(() => {

      })
    },
    //删除素材组
    materialgroupDelete(materialgroupObj) {
      const that = this
      this.$confirm('是否确认删除该分组？', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(function() {
        delMaterialGroup(materialgroupObj.materialGroupId)
          .then(function() {
            that.materialGroup={};
            that.getAllMaterialGroup()
          })
      })
      this.resetGroup();
      this.getAllMaterialGroup();
    },
    //修改素材组名称
    materialgroupEdit(materialgroupObj) {
      const that = this
      this.$prompt('请输入分组名', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        inputValue: materialgroupObj.materialGroupName
      }).then(({ value }) => {
        updateMaterialGroup({
          materialGroupId: materialgroupObj.materialGroupId,
          materialGroupName: value,
          groupType:2,
        }).then(function() {
          that.materialGroup={};
          that.getAllMaterialGroup()
        })
      }).catch(() => {

      })
    },
    //获取所有素材分组
    getAllMaterialGroup() {
      this.materialGroupLoading = true;
      listMaterialGroup({groupType:2}).then(response => {
        this.materialGroupList = response.rows
        this.materialGroupLoading = false;
      });
    },
    resetGroup(){
      this.queryParams= {
        pageNum: 1,
          pageSize: 10,
          groupType:2,
          materialGroupName: null,
          materialGroupId:null,
          materialUrl: null,
          createUserId: null,
      };
    },
    //查询分组 下的素材
    getMaterialList() {
      this.tableLoading = true;
      listMaterial(this.queryParams).then(response => {
        this.tableData = response.rows;
        this.total = response.total;
        this.tableLoading = false;
      });
    },
    //移动素材
    moveMaterial(index, type) {
      if (type == 'up') {
        const tempOption = this.value[index - 1]
        this.$set(this.value, index - 1, this.value[index])
        this.$set(this.value, index, tempOption)
      }
      if (type == 'down') {
        const tempOption = this.value[index + 1]
        this.$set(this.value, index + 1, this.value[index])
        this.$set(this.value, index, tempOption)
      }
    },
    //缩小图片
    zoomMaterial(index) {
      this.dialogVisible = true
      this.materialUrl = this.value[index]
    },
    //删除素材
    deleteMaterial(index) {
      const that = this
      this.$confirm('是否确认删除？', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(function() {
        that.value.splice(index, 1)
        that.urls = []
      })
    },

    toSeleteMaterial() {
      this.listDialogVisible = true
      this.getAllMaterialGroup()
      this.getMaterialList();
    },
    //删除素材
    materialDel(item) {
      const that = this
      this.$confirm('是否确认删除该素材？', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(function() {
        delMaterial(item.materialId)
          .then(function() {
            that.queryParams.pageNum=0;
            that.getMaterialList();
          })
      })
    },

    //上传进度
    handleProgress(event, file, fileList) {
    },
    //上传成功后
    handleSuccess(response, file, fileList) {
      const that = this
      addMaterial({
        materialType: 'image',
        materialGroupId: this.queryParams.materialGroupId,
        materialName: file.name,
        materialUrl: response.url,
        groupType:2,
      }).then(() => {
        this.resultNumber++
        if (fileList.length === this.resultNumber) {
          that.getMaterialList()
          this.resultNumber = 0
        }
      })
    },
    //上传之前
    beforeUpload(file) {
      const isPic =
        file.type === 'image/jpeg' ||
        file.type === 'image/png' ||
        file.type === 'image/gif' ||
        file.type === 'image/jpg'
      const isLt2M = file.size / 1024 / 1024 < 10
      if (!isPic) {
        this.$message.error('上传图片只能是 JPG、JPEG、PNG、GIF 格式!')
        return false
      }
      if (!isLt2M) {
        this.$message.error('上传图片大小不能超过 10MB!')
      }
      return isPic && isLt2M
    },
    //提交
    submit() {
      this.urls.forEach(item => {
        console.log("item",item)
        console.log("this.value",this.value)
        console.log("this.value.length",this.value.length)

        this.$set(this.value, this.value.length, item)
      })
      this.listDialogVisible = false
    }
  }
}
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
  ::v-deep .el-icon-circle-close{
    color: red;
  }
  .material-name{
    padding: 8px 0px;
  }
  .col-do{
    text-align: center;
  }
  .button-do{
    padding: unset!important;
    font-size: 12px;
  }
  .group-list{
    display: flex;
    flex-direction:column;
    align-items: flex-start;
  }
  .group-item{
    margin: 5px;
  }
</style>
